<?php if (!defined('ABSPATH')) {exit;}
/**
* Import of external products
*
* @link			https://icopydoc.ru/
* @since		1.8.7
*/
/*
$args_arr = array(
	'url' => 'https://site.ru/product/designside/',
	'name' => 'Товар через класс',
	'description' => 'Описание',
	'sku' => '0001',
	'catid' => array(72, 74),
	'regular_price' => 100,
	'sale_price' => 50,
	'stock_status' => 'instock',
	'pictures' => array('', ''),
	'attributes' => array(
		"Color2" => array("blue", "red"), 
		"Size3" => array('112', '13', '14')
	)

	'attributes_simple' => array(
		array('name' => 'Производитель', 'values' => array('Адидас', 'Найк')),
		array('name' => 'Страна', 'values' => array('Россия'))
	),
);
*/
class IPYTW_Import_Create_External_Product {
	private $offer_xml_object;
	private $feed_id;
	private $feed_product_id;
	
	private $url;
	private $name;
	private $description;
	private $sku;
	private $catid_arr;
	private $regular_price;
	private $sale_price;
	private $pictures_arr;
	private $attributes_simple_arr;

	private $imported_ids = false;

	public function __construct($args_arr, $offer_xml_object, $feed_id, $feed_product_id) {	
		$this->offer_xml_object = $offer_xml_object;
		$this->feed_id = $feed_id;
		$this->feed_product_id = $feed_product_id;	

		$this->url = $args_arr['url'];
		$this->name = $args_arr['name'];
		$this->description = $args_arr['description'];
		$this->sku = $args_arr['sku'];
		$this->catid_arr = $args_arr['catid'];
		$this->regular_price = $args_arr['regular_price'];
		$this->sale_price = $args_arr['sale_price'];
		$this->pictures_arr = $args_arr['pictures'];
		$this->attributes_simple_arr = $args_arr['attributes_simple'];
	}

	public function upd_product($product) {	
		/*
		if ($this->get_sku() !== '' && wc_get_product_id_by_sku($this->get_sku()) > 0) {
			$product = wc_get_product_id_by_sku($this->get_sku());
		} else {
			$product = new WC_Product();
		}
		*/
		$product = $this->set_external($product);
		
		$ipytw_product_was_sync = ipytw_optionGET('ipytw_product_was_sync', $this->get_feed_id(), 'set_arr');
		switch ($ipytw_product_was_sync) {
			case 'whole':
				return false;
				break; 
			case 'whole_except_cat':
				$this->catid_arr = $product->get_category_ids(); // $args_arr['catid'];
				return false;
				break;
			case 'price_only':
				$regular_price = $this->get_regular_price();
				$sale_price = $this->get_sale_price();
				if ($sale_price > 0) {
					$product->set_regular_price($sale_price);
					$product->set_sale_price($regular_price);
				} else {
					$product->set_regular_price($regular_price);
					$product->set_sale_price($sale_price);
				}
				$site_product_id = $product->save();	
				$this->save_info_about_sync($site_product_id);

				return true;
				break;
			case 'stock_only':
				return true;
				break;
			case 'price_and_stock':
				$regular_price = $this->get_regular_price();
				$sale_price = $this->get_sale_price();
				if ($sale_price > 0) {
					$product->set_regular_price($sale_price);
					$product->set_sale_price($regular_price);
				} else {
					$product->set_regular_price($regular_price);
					$product->set_sale_price($sale_price);
				}

//				$data_arr = array();
//				$data_arr['data']['offer_xml_object'] = $this->get_offer_xml_object();
//				$product = apply_filters('ipytw_product_upd_case_price_and_stock_filter', $product, $data_arr, $this->get_feed_id());

				$site_product_id = $product->save();
				$this->save_info_about_sync($site_product_id);

				return true;
				break;
			case 'dont_update': 
				return true;
				break;
			default:
//				$product = apply_filters('ipytw_product_upd_case_default_filter', $product, array('ipytw_product_was_sync' => $ipytw_product_was_sync, 'data' => $data), $this->get_feed_id());
				return true;
		}	
	}

	public function add_product() {
		$stop_flag = false;
		$stop_flag = apply_filters('ipytw_stop_flag_filter', $stop_flag, array('offer_xml_object' => $this->get_offer_xml_object()), $this->get_feed_id());
		if ($stop_flag === true) {
		   new IPYTW_Error_Log('NOTICE: Пропускаем товар $feed_product_id = '.$this->get_feed_product_id().' по флагу; Файл: offer.php; Строка: '.__LINE__);
		   return false;
		}

		// проверяем, существует ли товар с таким артикулом
		$product_sku = $this->get_sku();
		if (ipytw_is_uniq_sku($product_sku) === true) {
			new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; Товар с артикулом $product_sku = '.$product_sku.' уже существует; Файл: class-ipytw-import-add-simle-product.php; Строка: '.__LINE__);
			$ipytw_if_isset_sku = ipytw_optionGET('ipytw_if_isset_sku', $this->get_feed_id(), 'set_arr');
			if ($ipytw_if_isset_sku === 'disabled' || $ipytw_if_isset_sku === '') {
				new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; WARNING: Товар пропущен по причине дублирующегося артикула; Файл: class-ipytw-import-add-simle-product.php; Строка: '.__LINE__);
				return false;
			}
			if ($ipytw_if_isset_sku === 'update') {
				$check_sync_product = (int)wc_get_product_id_by_sku($product_sku);
			} else {
				$check_sync_product = ipytw_check_sync($this->get_feed_product_id(), $this->get_feed_id(), 'product');
			}
		} else {
			$check_sync_product = ipytw_check_sync($this->get_feed_product_id(), $this->get_feed_id(), 'product');
		}
	//	$check_sync_product = ipytw_check_sync($this->get_feed_product_id(), $this->get_feed_id(), 'product');
		if ($check_sync_product === false) {
			new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; Простой товар ранее не был импортирован; Файл: class-ipytw-import-add-simle-product.php; Строка: '.__LINE__);
			$product = new WC_Product();
		} else {
			$site_product_id = (int)$check_sync_product;
			new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; Простой товар ранее был импортирован $site_product_id = '.$site_product_id.'; Файл: class-ipytw-import-add-simle-product.php; Строка: '.__LINE__);
			$product = wc_get_product($site_product_id);
			$r = $this->upd_product($product);
			if ($r == true) {
				return $site_product_id;
			}
		}

		$product->set_name($this->get_name());

		$ipytw_description_into = ipytw_optionGET('ipytw_description_into', $this->get_feed_id(), 'set_arr');
		if ($ipytw_description_into === 'excerpt') {
			$product->set_short_description($this->get_description());
		} else {			
			$product->set_description($this->get_description());
		}

		$product->set_sku($this->get_sku());
		$product->set_category_ids($this->get_catid());
		$regular_price = $this->get_regular_price();
		$sale_price = $this->get_sale_price();
		if ($sale_price > 0) {
			$product->set_regular_price($sale_price);
			$product->set_sale_price($regular_price);
		} else {
			$product->set_regular_price($regular_price);
			$product->set_sale_price($sale_price);
		}

		$data_arr = array();
		$data_arr['data']['offer_xml_object'] = $this->get_offer_xml_object();
		$product = apply_filters('ipytw_product_add_before_save_filter', $product, $data_arr, $this->get_feed_id());
		$site_product_id = $product->save();

		$obj = new IPYTW_Import_Create_Product_Attributes($this->get_attributes_simple_arr(), $site_product_id);
		$attribs = $obj->create(false); // false - тк атрибуты не вариативные
		$product = new WC_Product_External($site_product_id);
		$product->set_props(array(
			'attributes' => $attribs,
			// Set any other properties of the product here you want - price, name, etc.
		));
		$product = $this->set_external($product);

		$img_ids_arr = array();
		foreach ($this->get_pictures_arr() as $feed_picture_url) {
			$check_sync_img = ipytw_check_sync($feed_picture_url, $this->get_feed_id(), 'attachment'); /* ! */ // picture 
			if ($check_sync_img === false) {

				/* Возможно вынести в отдельный класс */
				$ipytw_fsize_limit = ipytw_optionGET('ipytw_fsize_limit', $this->get_feed_id(), 'set_arr');
				$fsize_size = ipytw_fsize($feed_picture_url, 'MB', 'no', 0);
				if ($ipytw_fsize_limit > $fsize_size) { // размер файла в пределах лимита
					new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; $ipytw_fsize_limit = '.$ipytw_fsize_limit.' > $fsize_size = '.$fsize_size.'; Файл: class-ipytw-import-add-simle-product.php; Строка: '.__LINE__);
					$filename = basename(urldecode($feed_picture_url));
					if (!empty($filename)) {
						$upload_file = wp_upload_bits($filename, null, ipytw_file_get_contents_curl($feed_picture_url));
						if (!$upload_file['error']) {
							$wp_filetype = wp_check_filetype($filename, null);
							$attachment = array(
								'post_mime_type' => $wp_filetype['type'],
								'post_title' => $this->get_name(),
								'post_content' => '',
								'post_status' => 'inherit'
							);
							$image_id = wp_insert_attachment($attachment, $upload_file['file']);
							new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; wp_insert_attachment =>; Файл: class-ipytw-import-add-simle-product.php; Строка: '.__LINE__);
							if (!is_wp_error($image_id)) {
								new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; $image_id = '.$image_id.'; Файл: class-ipytw-import-add-simle-product.php; Строка: '.__LINE__);
								require_once(ABSPATH . "wp-admin" . '/includes/image.php');
								$attachment_data = wp_generate_attachment_metadata($image_id, $upload_file['file']);
								wp_update_attachment_metadata($image_id, $attachment_data);
							} else {
								new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; ERROR: Ошибка при загрузке картинки; Файл: class-ipytw-import-add-simle-product.php; Строка: '.__LINE__);
								new IPYTW_Error_Log($image_id, 0);			
							}
							update_post_meta($image_id, '_ipytw_import_feed_picture_url', $feed_picture_url);
							if (!class_exists('ImportProductsYMLtoWooCommercePro')) {
							$product->set_image_id($image_id);
								break;} else {
								$img_ids_arr[] = $image_id; 
								do_action('ipytw_img_add', array('img_id' => $image_id, 'product' => $product));
							}
						}
					}
				} else { // размер файла в пределах лимита
					new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; Размер картинки выше лимита. Пропускаем картинку $ipytw_fsize_limit = '.$ipytw_fsize_limit.'; $fsize_size = '.$fsize_size.'; Файл: class-ipytw-import-add-simle-product.php; Строка: '.__LINE__);
				}
				/* end Возможно вынести в отдельный класс */

			} else {
				$image_id = $check_sync_img;
				if (!class_exists('ImportProductsYMLtoWooCommercePro')) {
					$product->set_image_id($image_id);
					break;} else {
					$img_ids_arr[] = $image_id; 
					do_action('ipytw_img_add', array('img_id' => $image_id, 'product' => $product));
				}
			}
		}
		do_action('ipytw_imgs_add', array('img_ids_arr' => $img_ids_arr, 'product' => $product));

		$ipytw_post_status = ipytw_optionGET('ipytw_post_status', $this->get_feed_id(), 'set_arr');	
		$product->set_status($ipytw_post_status);
		$site_product_id = $product->save();	
		$this->save_info_about_sync($site_product_id);
		return $site_product_id;
	}

	private function save_info_about_sync($site_product_id) {
		$unixtime = current_time('Y-m-d H:i');
		update_post_meta($site_product_id, '_ipytw_feed_product_id', $this->get_feed_product_id()); // id товара в фиде
		update_post_meta($site_product_id, '_ipytw_feed_id', $this->get_feed_id()); // id фида
		update_post_meta($site_product_id, '_ipytw_date_last_import', $unixtime);

		$imported_ids = array();
		$imported_ids['feed_product_id'] = $this->get_feed_product_id();
		$imported_ids['site_product_id'] = $site_product_id;
		$imported_ids['feed_product_cat'] = 'null';
		$imported_ids['site_product_cat'] = $this->get_catid();
		$imported_ids['product_price'] = $this->get_regular_price();	
		$this->imported_ids = $imported_ids;
		return;
	}

	private function get_offer_xml_object() {
		return $this->offer_xml_object;
	}

	private function get_feed_id() {
		return $this->feed_id;
	}

	private function get_feed_product_id() {
		return $this->feed_product_id;
	}

	private function get_url() {
		return $this->url;
	}

	private function get_name() {
		return $this->name;
	}

	private function get_description() {
		return $this->description;
	}

	private function get_sku() {
		return $this->sku;
	}

	private function get_catid() {
		return $this->catid_arr;
	}

	private function get_regular_price() {
		return $this->regular_price;
	}

	private function get_sale_price() {
		return $this->sale_price;
	}

	private function get_pictures_arr() {
		return $this->pictures_arr;
	}

	private function get_attributes_simple_arr() {
		return $this->attributes_simple_arr;
	}
	
	public function get_imported_ids() {
		return $this->imported_ids;
	}

	private function set_external($product) {
		$ipytw_partner_link = ipytw_optionGET('ipytw_partner_link', $this->get_feed_id(), 'set_arr');
		$url = $this->get_url().$ipytw_partner_link;
		
		if ($product->get_type() == 'external') {
			if ($product->get_product_url() != $url) {
				$product->set_product_url($url);
				$site_product_id = $product->save();
				$product = wc_get_product($site_product_id);
			}
		} else {
			$site_product_id = $product->get_id();
			$product = new WC_Product_External($site_product_id);
			$product->set_product_url($url);
			$site_product_id = $product->save();
			$product = wc_get_product($site_product_id);						
		}

		return $product;
	}
}
?>