<?php if (!defined('ABSPATH')) {exit;}
/**
* Import of variable products
*
* @link			https://icopydoc.ru/
* @since		1.0.0
*/
/*
$args_arr = array(
	'name' => 'Товар через класс',
	'description' => 'Описание',
	'sku' => '0001',
	'catid' => array(72, 74),
	'stock_status' => 'instock',
	'pictures' => array(
		'https://icopydoc.ru/wp-content/uploads/2021/09/210924-import-from-yml-pro.jpg',
		'https://icopydoc.ru/wp-content/uploads/2020/10/201004-import-products-to-ok-ru-pro.jpg'
	),
	'attributes_simple' => array(
		"Производитель" => array("Адидас"), 
		"Страна" => array('Россия')
	),
	'attributes_variable' => array(
		"Color2" => array("blue", "red"), 
		"Size3" => array('46', '48')
	),
	'variations' => array(
			array(
				'attributes' => array(
					array('name' => 'Color2', 'value' => 'blue'),
					array('name' => 'Size3', 'value' => '46')
				),
				'feed_var_id' => 1,
				'description' => 'Описание вариации1',
				'sku' => '0001',
				'regular_price' => 60,
				'sale_price' => 50,
				'picture' => array(''),
				'stock_status' => 'instock'
			),
			array(
				'attributes' => array(
					array('name' => 'Color2', 'value' => 'blue'),
					array('name' => 'Size3', 'value' => '48')
				),
				'feed_var_id' => 3,
				'description' => 'Описание вариации2',
				'sku' => '0002',
				'regular_price' => 150,
				'sale_price' => 250,
				'picture' => array(''),
				'stock_status' => 'instock'
			)			
	)
);
*/
class IPYTW_Import_Create_Variable_Product {
	private $all_offers_of_variation_product;
	private $feed_id;
	private $feed_product_id;

	private $name;
	private $description;
	private $sku;
	private $catid_arr;
	private $stock_status;
	private $pictures_arr;
	private $attributes_simple_arr;
	private $attributes_variable_arr;
	private $variations_arr;

	private $imported_ids = false;

	public function __construct($args_arr, $all_offers_of_variation_product, $feed_id, $feed_product_id) {	
		$this->all_offers_of_variation_product = $all_offers_of_variation_product;
		$this->feed_id = $feed_id;
		$this->feed_product_id = $feed_product_id;	

		$this->name = $args_arr['name'];
		// $this->description = $args_arr['description'];
		$this->sku = $args_arr['sku'];
		$this->catid_arr = $args_arr['catid'];
		$this->stock_status = $args_arr['stock_status'];
		$this->pictures_arr = $args_arr['pictures'];
		$this->attributes_simple_arr = $args_arr['attributes_simple'];
		$this->attributes_variable_arr = $args_arr['attributes_variable'];
		$this->variations_arr = $args_arr['variations'];
	}

	public function upd_product($product) {	
		/*
		if ($this->get_sku() !== '' && wc_get_product_id_by_sku($this->get_sku()) > 0) {
			$product = wc_get_product_id_by_sku($this->get_sku());
		} else {
			$product = new WC_Product();
		}
		*/

		$ipytw_product_was_sync = ipytw_optionGET('ipytw_product_was_sync', $this->get_feed_id(), 'set_arr');
		switch ($ipytw_product_was_sync) {
			case 'whole': 				
				return false;			
				break; 
			case 'whole_except_cat':
				$this->catid_arr = $product->get_category_ids(); // $args_arr['catid'];
				return false;
				break;
			case 'price_only':
				for ($i = 0; $i < count($this->get_variations_arr()); $i++) {
					$variation_data_arr = $this->get_variations_arr()[$i];
					$check_sync_product = ipytw_check_sync($variation_data_arr['feed_var_id'], $this->get_feed_id(), 'product_variation');
					if ($check_sync_product === false) {
						continue;
					} else {
						$var_id = (int)$check_sync_product;
						new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; Вариация ранее была импортирована; $var_id = '.$var_id.'. Обновляем цену; Файл: class-ipytw-import-add-variable-product.php; Строка: '.__LINE__);
						$variation = wc_get_product($var_id);
					}
					
					if ($variation_data_arr['sale_price'] > 0) {
						$variation->set_regular_price($variation_data_arr['sale_price']);
						$variation->set_sale_price($variation_data_arr['regular_price']);
					} else {
						$variation->set_regular_price($variation_data_arr['regular_price']);
						$variation->set_sale_price($variation_data_arr['sale_price']);
					}
					$variation->save();			
					$unixtime = current_time('Y-m-d H:i');
					$var_id = $variation->get_id();
					update_post_meta($var_id, '_ipytw_date_last_import', $unixtime); 
				}
				return true;
				break;
			case 'stock_only':
				for ($i = 0; $i < count($this->get_variations_arr()); $i++) {
					$variation_data_arr = $this->get_variations_arr()[$i];
					$check_sync_product = ipytw_check_sync($variation_data_arr['feed_var_id'], $this->get_feed_id(), 'product_variation');
					if ($check_sync_product === false) {
						continue;
					} else {
						new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; Вариация ранее была импортирована; $var_id = '.$var_id.'. Обновляем остатки; Файл: class-ipytw-import-add-variable-product.php; Строка: '.__LINE__);
						$var_id = (int)$check_sync_product;
						$variation = wc_get_product($var_id);
					}
					
					$variation->set_stock_status($variation_data_arr['stock_status']);
					$variation = apply_filters('ipytw_variation_product_upd_case_stock_only_filter', $variation, array('variation_data_arr' => $variation_data_arr), $this->get_feed_id());

					$variation->save();			
					$unixtime = current_time('Y-m-d H:i');
					$var_id = $variation->get_id();
					update_post_meta($var_id, '_ipytw_date_last_import', $unixtime); 
				}
				return true;
				break;
			case 'price_and_stock':
				for ($i = 0; $i < count($this->get_variations_arr()); $i++) {
					$variation_data_arr = $this->get_variations_arr()[$i];
					$check_sync_product = ipytw_check_sync($variation_data_arr['feed_var_id'], $this->get_feed_id(), 'product_variation');
					if ($check_sync_product === false) {
						continue;
					} else {
						new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; Вариация ранее была импортирована; $var_id = '.$var_id.'. Обновляем цену и остатки; Файл: class-ipytw-import-add-variable-product.php; Строка: '.__LINE__);
						$var_id = (int)$check_sync_product;
						$variation = wc_get_product($var_id);
					}
					
					if ($variation_data_arr['sale_price'] > 0) {
						$variation->set_regular_price($variation_data_arr['sale_price']);
						$variation->set_sale_price($variation_data_arr['regular_price']);
					} else {
						$variation->set_regular_price($variation_data_arr['regular_price']);
						$variation->set_sale_price($variation_data_arr['sale_price']);
					}

					$variation->set_stock_status($variation_data_arr['stock_status']);
					$variation = apply_filters('ipytw_variation_product_upd_case_price_and_stock_filter', $variation, array('variation_data_arr' => $variation_data_arr), $this->get_feed_id());

					$variation->save();			
					$unixtime = current_time('Y-m-d H:i');
					$var_id = $variation->get_id();
					update_post_meta($var_id, '_ipytw_date_last_import', $unixtime); 
				}

				/*
				$site_product_id = $product->save();
				$this->save_info_about_sync($site_product_id);
				*/
				return true;
				break;
			case 'dont_update': 
				return true;
				break;
			default:
//				$product = apply_filters('ipytw_variation_product_upd_case_default_filter', $product, array('get_all_offers_of_variation_product' => $this->get_all_offers_of_variation_product()), $this->get_feed_id());
				return true;
		}	
	}

	public function add_product() {
		$ipytw_whot_import = ipytw_optionGET('ipytw_whot_import', $this->get_feed_id(), 'set_arr');
		if ($ipytw_whot_import !== 'all') {
			return false; 
		}
				
		$check_sync_product = ipytw_check_sync($this->get_feed_product_id(), $this->get_feed_id(), 'product');
		if ($check_sync_product === false) {
			new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; Вариативный товар ранее не был импортирован; Файл: class-ipytw-import-add-variable-product.php; Строка: '.__LINE__);
			$product = new WC_Product();
		} else {
			$site_product_id = (int)$check_sync_product;
			new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; Вариативный товар ранее был импортирован $site_product_id = '.$site_product_id.'; Файл: class-ipytw-import-add-variable-product.php; Строка: '.__LINE__);
			$product = wc_get_product($site_product_id);
			if ($product->is_type('simple')) {
				$product = new WC_Product_Variable($site_product_id);
				$site_product_id = $product->save();
				$product = wc_get_product($site_product_id);
				new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; Вариативный $site_product_id = '.$site_product_id.' товар ранее был простым, а теперь товар стал '.$product->get_type().'; Файл: class-ipytw-import-add-variable-product.php; Строка: '.__LINE__);
				// полностью обновим
			} else {
				$r = $this->upd_product($product);
				if ($r == true) {
					return $site_product_id;
				}
			}
		}

		$product->set_name($this->get_name());

		$ipytw_description_into = ipytw_optionGET('ipytw_description_into', $this->get_feed_id(), 'set_arr');
		if ($ipytw_description_into === 'excerpt') {
			$product->set_short_description($this->get_description());
		} else {			
			$product->set_description($this->get_description());
		}

		$product->set_sku($this->get_sku());
		$product->set_category_ids($this->get_catid());
		$product->set_stock_status($this->get_stock_status());

		$product = apply_filters('ipytw_variation_product_add_before_save_filter', $product, array('get_all_offers_of_variation_product' => $this->get_all_offers_of_variation_product()), $this->get_feed_id());
		$site_product_id = $product->save();

		$obj1 = new IPYTW_Import_Create_Product_Attributes($this->get_attributes_simple_arr(), $site_product_id);
		$attribs1 = $obj1->create(false); // false - тк атрибуты не вариативные
		$obj2 = new IPYTW_Import_Create_Product_Attributes($this->get_attributes_variable_arr(), $site_product_id);
		$attribs2 = $obj2->create(true); // true - тк атрибуты вариативные
		$attribs = array_merge($attribs1, $attribs2);
		$product = new WC_Product_Variable($site_product_id);
		$product->set_props(array(
			'attributes' => $attribs,
			// Set any other properties of the product here you want - price, name, etc.
		));
		$site_product_id = $product->save();

		$img_ids_arr = array();
		foreach ($this->get_pictures_arr() as $feed_picture_url) {
			$check_sync_img = ipytw_check_sync($feed_picture_url, $this->get_feed_id(), 'attachment'); /* ! */ // picture 
			if ($check_sync_img === false) {

				/* Возможно вынести в отдельный класс */
				$ipytw_fsize_limit = ipytw_optionGET('ipytw_fsize_limit', $this->get_feed_id(), 'set_arr');
				$fsize_size = ipytw_fsize($feed_picture_url, 'MB', 'no', 0);
				if ($ipytw_fsize_limit > $fsize_size) { // размер файла в пределах лимита
					new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; $ipytw_fsize_limit = '.$ipytw_fsize_limit.' > $fsize_size = '.$fsize_size.'; Файл: class-ipytw-import-add-variable-product.php; Строка: '.__LINE__);
					$filename = basename(urldecode($feed_picture_url));
					if (!empty($filename)) {
						$upload_file = wp_upload_bits($filename, null, ipytw_file_get_contents_curl($feed_picture_url));
						if (!$upload_file['error']) {
							$wp_filetype = wp_check_filetype($filename, null);
							$attachment = array(
								'post_mime_type' => $wp_filetype['type'],
								'post_title' => $this->get_name(),
								'post_content' => '',
								'post_status' => 'inherit'
							);
							$image_id = wp_insert_attachment($attachment, $upload_file['file']);
							new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; wp_insert_attachment =>; Файл: class-ipytw-import-add-variable-product.php; Строка: '.__LINE__);
							if (!is_wp_error($image_id)) {
								new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; $image_id = '.$image_id.'; Файл: class-ipytw-import-add-variable-product.php; Строка: '.__LINE__);
								require_once(ABSPATH . "wp-admin" . '/includes/image.php');
								$attachment_data = wp_generate_attachment_metadata($image_id, $upload_file['file']);
								wp_update_attachment_metadata($image_id, $attachment_data);
							} else {
								new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; ERROR: Ошибка при загрузке картинки; Файл: class-ipytw-import-add-variable-product.php; Строка: '.__LINE__);
								new IPYTW_Error_Log($image_id, 0);			
							}
							update_post_meta($image_id, '_ipytw_import_feed_picture_url', $feed_picture_url);
							if (!class_exists('ImportProductsYMLtoWooCommercePro')) {
							$product->set_image_id($image_id);
								break;} else {
								$img_ids_arr[] = $image_id; 
								do_action('ipytw_img_add', array('img_id' => $image_id, 'product' => $product));
							}
						}
					}
				} else { // размер файла в пределах лимита
					new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; Размер картинки выше лимита. Пропускаем картинку $ipytw_fsize_limit = '.$ipytw_fsize_limit.'; $fsize_size = '.$fsize_size.'; Файл: class-ipytw-import-add-variable-product.php; Строка: '.__LINE__);
				}
				/* end Возможно вынести в отдельный класс */

			} else {
				$image_id = $check_sync_img;
				if (!class_exists('ImportProductsYMLtoWooCommercePro')) {
					$product->set_image_id($image_id);
					break;} else {
					$img_ids_arr[] = $image_id; 
					do_action('ipytw_img_add', array('img_id' => $image_id, 'product' => $product));
				}
			}
		}
		do_action('ipytw_imgs_add', array('img_ids_arr' => $img_ids_arr, 'product' => $product));

		$site_product_id = $product->save();
		
		// https://hotexamples.com/examples/-/WC_Product_Variation/-/php-wc_product_variation-class-examples.html
		for ($i = 0; $i < count($this->get_variations_arr()); $i++) {
			$variation_data_arr = $this->get_variations_arr()[$i];
			$attributes_arr = $variation_data_arr['attributes'];

			$for_set_attributes_arr = array();
			for ($ii = 0; $ii < count($attributes_arr); $ii++) {
				$pa_slug = (string)$this->get_attribute_pa_slug($attributes_arr[$ii]['name']);
				$for_set_attributes_arr[$pa_slug] = $this->get_attribute_value_pa_slug((string)$attributes_arr[$ii]['value'], $pa_slug); // (string)$attributes_arr[$ii]['value'];
			}

			$check_sync_product = ipytw_check_sync($variation_data_arr['feed_var_id'], $this->get_feed_id(), 'product_variation');
			if ($check_sync_product === false) {
				new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; Вариация ранее не была импортирована; $this->get_feed_product_id() = '.$this->get_feed_product_id().'; Файл: class-ipytw-import-add-variable-product.php; Строка: '.__LINE__);
				$variation = new \WC_Product_Variation();
				$variation->set_parent_id($product->get_id());
				$variation->set_attributes($for_set_attributes_arr); // array('pa_color2' => 'blue', 'pa_size3' => '46')
				$variation->save();
				// echo get_array_as_string($for_set_attributes_arr, '<br/>');
			} else {
				$var_id = (int)$check_sync_product;
				new IPYTW_Error_Log('FEED № '.$this->get_feed_id().'; Вариация ранее была импортирована; $var_id = '.$var_id.'; Файл: class-ipytw-import-add-variable-product.php; Строка: '.__LINE__);
				$variation = wc_get_product($var_id);
				// $variation->set_attributes($for_set_attributes_arr); // array('pa_color2' => 'blue', 'pa_size3' => '46')
				// $variation->save();
			}

			if ($variation_data_arr['sale_price'] > 0) {
				$variation->set_regular_price($variation_data_arr['sale_price']);
				$variation->set_sale_price($variation_data_arr['regular_price']);
			} else {
				$variation->set_regular_price($variation_data_arr['regular_price']);
				$variation->set_sale_price($variation_data_arr['sale_price']);
			}
			$variation->set_length($variation_data_arr['length']); // Задаёт длину товара
			$variation->set_width($variation_data_arr['width']); // Задаёт ширину товара
			$variation->set_height($variation_data_arr['height']); // Задаёт высоту товара */
			$variation->set_weight($variation_data_arr['weight']); // Задаёт вес товара
			$variation->set_stock_status($variation_data_arr['stock_status']);
			// $variation_2->set_date_on_sale_to('32532537600');
	//		$variation->set_status('private');
			$variation->save();
			// Now update some value unrelated to attributes.
			$variation = wc_get_product($variation->get_id());
			$variation->set_status('publish');
			$variation->save();
			
			$unixtime = current_time('Y-m-d H:i');
			$var_id = $variation->get_id();
			update_post_meta($var_id, '_ipytw_feed_var_id', (string)$variation_data_arr['feed_var_id']); // id вариации товара в фиде
			update_post_meta($var_id, '_ipytw_feed_id', $this->get_feed_id()); // id фида
			update_post_meta($var_id, '_ipytw_date_last_import', $unixtime); 
		}

	/*	// Create a new variation with the color 'green'.
		$variation = new \WC_Product_Variation();
		$variation->set_parent_id($product->get_id());
		$variation->set_attributes(array('pa_color2' => 'blue', 'pa_size3' => '112'));
		$variation->set_regular_price(22);
		$variation->set_status('private');
		$variation->save();
		// Now update some value unrelated to attributes.
		$variation = wc_get_product($variation->get_id());
		$variation->set_status('publish');
		$variation->save();
		*/
		$ipytw_post_status = ipytw_optionGET('ipytw_post_status', $this->get_feed_id(), 'set_arr');	
		$product->set_status($ipytw_post_status);
		
		$this->save_info_about_sync($site_product_id);
		return $site_product_id;
	}
	
	private function save_info_about_sync($site_product_id) {
		$unixtime = current_time('Y-m-d H:i');
		update_post_meta($site_product_id, '_ipytw_feed_product_id', $this->get_feed_product_id()); // id товара в фиде
		update_post_meta($site_product_id, '_ipytw_feed_id', $this->get_feed_id()); // id фида
		update_post_meta($site_product_id, '_ipytw_date_last_import', $unixtime);
	
		$imported_ids = array();
		$imported_ids['feed_product_id'] = $this->get_feed_product_id();
		$imported_ids['site_product_id'] = $site_product_id;
		$imported_ids['feed_product_cat'] = 'null';
		$imported_ids['site_product_cat'] = $this->get_catid();
		$imported_ids['product_price'] = 'null';		
		$this->imported_ids = $imported_ids;
		return;
	}

	private function get_attribute_pa_slug($search_string) {
		$attribute_taxonomies = wc_get_attribute_taxonomies();
		if (count($attribute_taxonomies) > 0) {
		   	foreach($attribute_taxonomies as $one_tax) {
				/**
				* $one_tax->attribute_id => 6
				* $one_tax->attribute_name] => слаг (на инглише или русском)
				* $one_tax->attribute_label] => Еще один атрибут (это как раз название)
				* $one_tax->attribute_type] => select 
				* $one_tax->attribute_orderby] => menu_order
				* $one_tax->attribute_public] => 0			
				*/				 
				if ($search_string == $one_tax->attribute_label) {
					$id = (int)$one_tax->attribute_id;
					return wc_attribute_taxonomy_name_by_id($id);
				}
			}			
		}
		return false;
	}

	private function get_attribute_value_pa_slug($search_string, $attribute_pa_slug) {
		$attribute_taxonomies = get_terms($attribute_pa_slug, [
			'hide_empty' => false,
		]);
		if (count($attribute_taxonomies) > 0) {
		   	foreach($attribute_taxonomies as $one_tax) {
				/**
				* $one_tax->term_id]     => 162
				* $one_tax->name]        => Здоровье
				* $one_tax->slug]        => zdorove
				* $one_tax->term_group]  => 0
				* $one_tax->term_taxonomy_id] => 170
				* $one_tax->taxonomy]    => my_taxonomy
				* $one_tax->description] =>
				* $one_tax->parent]      => 0
				* $one_tax->count]       => 2		
				*/
				if ($search_string == $one_tax->name) {
					// $id = (int)$one_tax->term_id;
					return $one_tax->slug;					
				}
			}			
		}
		return false;
	}

	private function get_all_offers_of_variation_product() {
		return $this->all_offers_of_variation_product;
	}

	private function get_feed_id() {
		return $this->feed_id;
	}

	private function get_feed_product_id() {
		return $this->feed_product_id;
	}

	private function get_name() {
		return $this->name;
	}

	private function get_description() {
		return $this->description;
	}

	private function get_sku() {
		return $this->sku;
	}

	private function get_catid() {
		return $this->catid_arr;
	}
	
	private function get_stock_status() {
		return $this->stock_status;
	}	

	private function get_pictures_arr() {
		return $this->pictures_arr;
	}

	private function get_attributes_simple_arr() {
		return $this->attributes_simple_arr;
	}

	private function get_attributes_variable_arr() {
		return $this->attributes_variable_arr;
	}

	private function get_variations_arr() {
		return $this->variations_arr;
	}

	public function get_imported_ids() {
		return $this->imported_ids;
	}
}
?>